;
; Tank.txt
;
; Macro for drawing a fuel or other liquid storage tank. This object is
; visible for 10 km.
;
; Usage:
;
;        macro( tank.txt L Lo color )
;
;        L      latitude
;        Lo     longitude
;        color  color
;
; Example:
;
;        macro( tank.txt 45:46:41.3300 -84:43:29.4700 0D )
;

Area( B  %1  %2  10 )

PerspectiveCall( :Tank )
Jump( :End)

:Tank
Perspective
RefPoint( 7 :Return 0.25 %1 %2 V1= 10000 V2= 0 )

VecPoints( xy 1
          -30    0    0 ;  1
          -27    0   11 ;  2
          -21    0   21 ;  3
          -11    0   27 ;  4
            0    0   30 ;  5
           11    0   27 ;  6
           21    0   21 ;  7
           27    0   11 ;  8
           30    0    0 ;  9
           27    0  -11 ; 10
           21    0  -21 ; 11
           11    0  -27 ; 12
            0    0  -30 ; 13
          -11    0  -27 ; 14
          -21    0  -21 ; 15
          -27    0  -11 ; 16
          -30   30    0 ; 17
          -27   30   11 ; 18
          -21   30   21 ; 19
          -11   30   27 ; 20
            0   30   30 ; 21
           11   30   27 ; 22
           21   30   21 ; 23
           27   30   11 ; 24
           30   30    0 ; 25
           27   30  -11 ; 26
           21   30  -21 ; 27
           11   30  -27 ; 28
            0   30  -30 ; 39
          -11   30  -27 ; 30
          -21   30  -21 ; 31
          -27   30  -11 ; 32
	)

Points( 51
          -30   30    0 ; 51
          -27   30   11 ; 52
          -21   30   21 ; 53
          -11   30   27 ; 54
            0   30   30 ; 55
           11   30   27 ; 56
           21   30   21 ; 57
           27   30   11 ; 58
           30   30    0 ; 59
           27   30  -11 ; 60
           21   30  -21 ; 61
           11   30  -27 ; 62
            0   30  -30 ; 63
          -11   30  -27 ; 64
          -21   30  -21 ; 65
          -27   30  -11 ; 66
	)
	 
ShadedColor( %3 F0 )

Smoothing( 1 )
ShadedPoly( a  1  2 18 17 )
ShadedPoly( a  2  3 19 18 )
ShadedPoly( a  3  4 20 19 )
ShadedPoly( a  4  5 21 20 )
ShadedPoly( a  5  6 22 21 )
ShadedPoly( a  6  7 23 22 )
ShadedPoly( a  7  8 24 23 )
ShadedPoly( a  8  9 25 24 )
ShadedPoly( a  9 10 26 25 )
ShadedPoly( a 10 11 27 26 )
ShadedPoly( a 11 12 28 27 )
ShadedPoly( a 12 13 29 28 )
ShadedPoly( a 13 14 30 29 )
ShadedPoly( a 14 15 31 30 )
ShadedPoly( a 15 16 32 31 )
ShadedPoly( a 16  1 17 32 )
Smoothing( 0 )

Poly( a 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 )

:Return
Return

:End
EndA
