;
; WaterTank.txt
;
; Macro for drawing a water storage tank. This object is
; visible for 10 km.
;
; Usage:
;
;        macro( WaterTank.txt L Lo color )
;
;        L      latitude
;        Lo     longitude
;        color  color
;
; Example:
;
;        macro( WaterTank.txt 45:46:41.3300 -84:43:29.4700 04 )
;

Area( B  %1  %2  10 )

PerspectiveCall( :WaterTank )
Jump( :End)

:WaterTank
Perspective
RefPoint( 7 :Return 0.25 %1 %2 V1= 10000 V2= 0 )

VecPoints( a  1
           -3    0    0 ;   1
           -2    0    2 ;   2
            0    0    3 ;   3
            2    0    2 ;   4
            3    0    0 ;   5
            2    0   -2 ;   6
            0    0   -3 ;   7
           -2    0   -2 ;   8
           -3  130    0 ;   9
           -2  130    2 ;  10
            0  130    3 ;  11
            2  130    2 ;  12
            3  130    0 ;  13
            2  130   -2 ;  14
            0  130   -3 ;  15
           -2  130   -2 ;  16
        )

VecPoints( a  51
          -15  140    0 ;  51
          -13  140    5 ;  52
          -10  140   10 ;  53
           -5  140   13 ;  54
            0  140   15 ;  55
            5  140   13 ;  56
           10  140   10 ;  57
           13  140    5 ;  58
           15  140    0 ;  59
           13  140   -5 ;  60
           10  140  -10 ;  61
            5  140  -13 ;  62
            0  140  -15 ;  63
           -5  140  -13 ;  64
          -10  140  -10 ;  65
          -13  140   -5 ;  66
          -15  150    0 ;  67
          -13  150    5 ;  68
          -10  150   10 ;  69
           -5  150   13 ;  70
            0  150   15 ;  71
            5  150   13 ;  72
           10  150   10 ;  73
           13  150    5 ;  74
           15  150    0 ;  75
           13  150   -5 ;  76
           10  150  -10 ;  77
            5  150  -13 ;  78
            0  150  -15 ;  79
           -5  150  -13 ;  80
          -10  150  -10 ;  81
          -13  150   -5 ;  82
        )

VecPoints( a  101
           -7  130    0 ; 101
           -6  130    2 ; 102
           -4  130    4 ; 103
           -2  130    6 ; 104
            0  130    7 ; 105
            2  130    6 ; 106
            4  130    4 ; 107
            6  130    2 ; 108
            7  130    0 ; 109
            6  130   -2 ; 110
            4  130   -4 ; 111
            2  130   -6 ; 112
            0  130   -7 ; 113
           -2  130   -6 ; 114
           -4  130   -4 ; 115
           -6  130   -2 ; 116
        )

VecPoints( a  151
           -7  160    0 ; 151
           -6  160    2 ; 152
           -4  160    4 ; 153
           -2  160    6 ; 154
            0  160    7 ; 155
            2  160    6 ; 156
            4  160    4 ; 157
            6  160    2 ; 158
            7  160    0 ; 159
            6  160   -2 ; 160
            4  160   -4 ; 161
            2  160   -6 ; 162
            0  160   -7 ; 163
           -2  160   -6 ; 164
           -4  160   -4 ; 165
           -6  160   -2 ; 166
        )

Points(   201
           -7  160    0 ; 201
           -6  160    2 ; 202
           -4  160    4 ; 203
           -2  160    6 ; 204
            0  160    7 ; 205
            2  160    6 ; 206
            4  160    4 ; 207
            6  160    2 ; 208
            7  160    0 ; 209
            6  160   -2 ; 210
            4  160   -4 ; 211
            2  160   -6 ; 212
            0  160   -7 ; 213
           -2  160   -6 ; 214
           -4  160   -4 ; 215
           -6  160   -2 ; 216
        )

Points(   251
           -7  130    0 ; 251
           -6  130    2 ; 252
           -4  130    4 ; 253
           -2  130    6 ; 254
            0  130    7 ; 255
            2  130    6 ; 256
            4  130    4 ; 257
            6  130    2 ; 258
            7  130    0 ; 259
            6  130   -2 ; 260
            4  130   -4 ; 261
            2  130   -6 ; 262
            0  130   -7 ; 263
           -2  130   -6 ; 264
           -4  130   -4 ; 265
           -6  130   -2 ; 266
        )

ShadedColor( %3 F0 )
Smoothing( 1 )

ShadedPoly( a    1   2  10   9 )
ShadedPoly( a    2   3  11  10 )
ShadedPoly( a    3   4  12  11 )
ShadedPoly( a    4   5  13  12 )
ShadedPoly( a    5   6  14  13 )
ShadedPoly( a    6   7  15  14 )
ShadedPoly( a    7   8  16  15 )
ShadedPoly( a    8   1   9  16 )

ShadedPoly( a   51  52  68  67 )
ShadedPoly( a   52  53  69  68 )
ShadedPoly( a   53  54  70  69 )
ShadedPoly( a   54  55  71  70 )
ShadedPoly( a   55  56  72  71 )
ShadedPoly( a   56  57  73  72 )
ShadedPoly( a   57  58  74  73 )
ShadedPoly( a   58  59  75  74 )
ShadedPoly( a   59  60  76  75 )
ShadedPoly( a   60  61  77  76 )
ShadedPoly( a   61  62  78  77 )
ShadedPoly( a   62  63  79  78 )
ShadedPoly( a   63  64  80  79 )
ShadedPoly( a   64  65  81  80 )
ShadedPoly( a   65  66  82  81 )
ShadedPoly( a   66  51  67  82 )

ShadedPoly( ai 101 102  52  51 )
ShadedPoly( ai 102 103  53  52 )
ShadedPoly( ai 103 104  54  53 )
ShadedPoly( ai 104 105  55  54 )
ShadedPoly( ai 105 106  56  55 )
ShadedPoly( ai 106 107  57  56 )
ShadedPoly( ai 107 108  58  57 )
ShadedPoly( ai 108 109  59  58 )
ShadedPoly( ai 109 110  60  59 )
ShadedPoly( ai 110 111  61  60 )
ShadedPoly( ai 111 112  62  61 )
ShadedPoly( ai 112 113  63  62 )
ShadedPoly( ai 113 114  64  63 )
ShadedPoly( ai 114 115  65  64 )
ShadedPoly( ai 115 116  66  65 )
ShadedPoly( ai 116 101  51  66 )

ShadedPoly( a  151 152  68  67 )
ShadedPoly( a  152 153  69  68 )
ShadedPoly( a  153 154  70  69 )
ShadedPoly( a  154 155  71  70 )
ShadedPoly( a  155 156  72  71 )
ShadedPoly( a  156 157  73  72 )
ShadedPoly( a  157 158  74  73 )
ShadedPoly( a  158 159  75  74 )
ShadedPoly( a  159 160  76  75 )
ShadedPoly( a  160 161  77  76 )
ShadedPoly( a  161 162  78  77 )
ShadedPoly( a  162 163  79  78 )
ShadedPoly( a  163 164  80  79 )
ShadedPoly( a  164 165  81  80 )
ShadedPoly( a  165 166  82  81 )
ShadedPoly( a  166 151  67  82 )

Smoothing( 0 )

Poly( 0  32767 0 0  201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 )
Poly( 0 -32767 0 0  251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 )

IfVarAnd( :Return 28C FFFE )
LineColor( F F0 )
Brightness( 100 )
Dot( 0 161 0 )

:Return
Return

:End
EndA