;
;       Macro( windmil2.scm  NN  EE  deg  color1 color2 )
;                            1   2   3    4      5
;                                         base   roof
;
Area( 5 %1 %2 12 )
    PerspectiveCall( :A0 )
    Jump( : )

:A0
    Perspective
    RefPoint( 7 :E 0.25 %1 %2  )
    Monitor3D( :nocrash -3 3 0 12 -3 3 )
    SetVar( 284 14 )
:nocrash
    RotatedCall( :A02 0 0 %3 )
    Return

:A02
    VectorJump( :A03 0 0 -32767  10 )
    Call( :body )
    Call( :wings )
    Return

:A03
    Call( :wings )
    Call( :body )
    Return

:body
    ShadowCall( :body2 )
:body2
    Points( 0
	-12  0  0	-8  0  8	0  0  12	 8  0  8
	 12  0  0	 8  0 -8	0  0 -12	-8  0 -8

	-12 12  0	-8 12  8	0 12  12	 8 12  8
	 12 12  0	 8 12 -8	0 12 -12	-8 12 -8

	-20 12  0	-14 12  14	0 12  20	 14 12  14
	 20 12  0	 14 12 -14	0 12 -20	-14 12 -14

	-12 16  0	-8 16  8	0 16  12	 8 16  8
	 12 16  0	 8 16 -8	0 16 -12	-8 16 -8


	 -8 24  0	-6 24  6	0 24   8	 6 24  6
	  8 24  0	 6 24 -6	0 24  -8	-6 24 -6

	 -6 40  0	-4 40  4	0 40   6	 4 40  4
	  6 40  0	 4 40 -4	0 40  -6	-4 40 -4
    )
    VectorPoints( xy 48
	 -6 40 -6	-6 40  0	-4 40  4	 0 40  6
	  4 40  4	 6 40  0	 6 40 -6
    )
    VectorPoints( a 55
	 -4 44 -6	-4 44  0	-3 44  3	 0 44  4
	  3 44  3	 4 44  0	 3 44 -6
	  0 48 -6
	  0 48  0
    )

    VectorJump( :down 0 1 0  12 )
    Call( :base )
    Call( :tower )
    Return

:down
    Call( :tower )
    Call( :base )
    Return

:base
    ; Galerie Unterseite
    SurfaceColor( 2 F0 )
    Poly( ad  8 16 17  9 )
    Poly( ad  9 17 18 10 )
    Poly( ad 10 18 19 11 )
    Poly( ad 11 19 20 12 )
    Poly( ad 12 20 21 13 )
    Poly( ad 13 21 22 14 )
    Poly( ad 14 22 23 15 )
    Poly( ad 15 23 16  8 )

    ;Unterbau, Seitenwnde / base, side walls
    SurfaceColor( %4 F0 )
    Poly( a  0 1  9  8 )
    Poly( a  1 2 10  9 )
    Poly( a  2 3 11 10 )
    Poly( a  3 4 12 11 )
    Poly( a  4 5 13 12 )
    Poly( a  5 6 14 13 )
    Poly( a  6 7 15 14 )
    Poly( a  7 0  8 15 )
    Return

:tower
    ; Turmteil
    SurfaceColor( 1 F0 )
    Poly( ad 48 49 50 51 52 53 54 )
    SurfaceColor( 3 F0 )
    Poly( a  8 16 17  9 )
    Poly( a  9 17 18 10 )
    Poly( a 10 18 19 11 )
    Poly( a 11 19 20 12 )
    Poly( a 12 20 21 13 )
    Poly( a 13 21 22 14 )
    Poly( a 14 22 23 15 )
    Poly( a 15 23 16  8 )

    SurfaceColor( %4 F0 )
    Poly( a  8  9 25 24 )
    Poly( a  9 10 26 25 )
    Poly( a 10 11 27 26 )
    Poly( a 11 12 28 27 )
    Poly( a 12 13 29 28 )
    Poly( a 13 14 30 29 )
    Poly( a 14 15 31 30 )
    Poly( a 15  8 24 31 )

    SurfaceColor( %5 F0 )
    Poly( a 24 25 33 32 )
    Poly( a 25 26 34 33 )
    Poly( a 26 27 35 34 )
    Poly( a 27 28 36 35 )
    Poly( a 28 29 37 36 )
    Poly( a 29 30 38 37 )
    Poly( a 30 31 39 38 )
    Poly( a 31 24 32 39 )

    Poly( a 32 33 41 40 )
    Poly( a 33 34 42 41 )
    Poly( a 34 35 43 42 )
    Poly( a 35 36 44 43 )
    Poly( a 36 37 45 44 )
    Poly( a 37 38 46 45 )
    Poly( a 38 39 47 46 )
    Poly( a 39 32 40 47 )

    ; Kuppel (roof)
    ShadedColor( %5 F0 )
    ShadedPoly( a 48 49 56 55 )
    ShadedPoly( a 49 50 57 56 )
    ShadedPoly( a 50 51 58 57 )
    ShadedPoly( a 51 52 59 58 )
    ShadedPoly( a 52 53 60 59 )
    ShadedPoly( a 53 54 61 60 )

    ShadedPoly( a 55 56 63 62 )
    ShadedPoly( a 56 57 63 )
    ShadedPoly( a 57 58 63 )
    ShadedPoly( a 58 59 63 )
    ShadedPoly( a 59 60 63 )
    ShadedPoly( a 60 61 62 63 )
    SurfaceColor( 4 F0 )
    Poly( a 48 55 62 61 54 )

    Return

:wings
    IfVarRange( :norot 346 2 4 )
    IfVarAnd( :norot 28C 1 )
    IfVarRange( :norot 382 0 4000 )
    IfVarRange( :norot 37E -8000 8000 )
    IfVarRange( :norot 386 -8000 8000 )

    IfVarAnd( :A1 282 0003 )
    TransformCall( :draw_wing 0 44 0  10 0  00.00 0  0 0 )
    Return

:A1
    IfVarAnd( :A2 282 000C )
    TransformCall( :draw_wing 0 44 0  10 0  11.25 0  0 0 )
    Return

:A2
    IfVarAnd( :A3 282 0030 )
    TransformCall( :draw_wing 0 44 0  10 0  22.50 0  0 0 )
    Return

:A3
    IfVarAnd( :A4 282 00C0 )
    TransformCall( :draw_wing 0 44 0  10 0  33.75 0  0 0 )
    Return

:A4
    IfVarAnd( :A5 282 0300 )
    TransformCall( :draw_wing 0 44 0  10 0  45.00 0  0 0 )
    Return

:A5
    IfVarAnd( :A6 282 0C00 )
    TransformCall( :draw_wing 0 44 0  10 0  56.25 0  0 0 )
    Return

:A6
    IfVarAnd( :A7 282 3000 )
    TransformCall( :draw_wing 0 44 0  10 0  67.50 0  0 0 )
    Return

:A7
    IfVarAnd( :E 282 C000 )
    TransformCall( :draw_wing 0 44 0  10 0  78.75 0  0 0 )
:E
    Return

:norot
    TransformCall( :draw_wing 0 44 0  10 0  33.75 0  0 0 )
    Return

:draw_wing
    Points( 0
	-6  0 -10	-32   0 -10	-32   6 -10	-6  6 -10
	 0  6 -10	  0  32 -10	  6  32 -10	 6  6 -10
	 6  0 -10	 32   0 -10	 32  -6 -10	 6 -6 -10
	 0 -6 -10	  0 -32 -10	 -6 -32 -10	-6 -6 -10
	 0  0 -10	  0   0 -6
    )
    LineColor( 1 F0 )
    MoveToPt( 16 )
    DrawToPt( 17 )
    SurfaceColor( 3 F0 )
    StartSurface
    MoveToPt( 0 )
    DrawToPt( 1 2 3 )
    EndSurface
    StartSurface
    MoveToPt( 4 )
    DrawToPt( 5 6 7 )
    EndSurface
    StartSurface
    MoveToPt( 8 )
    DrawToPt( 9 10 11 )
    EndSurface
    StartSurface
    MoveToPt( 12 )
    DrawToPt( 13 14 15 )
    EndSurface
    LineColor( 1 F0 )
    MoveToPt( 1 )
    DrawToPt( 9 )
    MoveToPt( 5 )
    DrawToPt( 13 )
    Return

EndA
